﻿#region System Namespace
using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.IO;
using System.Threading;
#endregion System Namespace

#region Foreign Namespace
using AIMLbot;
#endregion Foreign Namespace

#region Styx Namespace
using Styx;
using Styx.Plugins;
using Styx.Common;
using Styx.CommonBot;
#endregion Styx Namespace

namespace AIMLWhisper
{
    public class Response
    {
        public readonly string Message;
        public readonly string User;

        public Response(string userName, string message)
        {
            User = userName;
            Message = message;
        }
    }

    public class AimlWhisper : HBPlugin
    {
        public Bot _aimlBot;
        public List<Response> _responseList;
        public List<User> _userList;

        public override string Name { get { return "AIMLWhisper"; } }
        public override string Author { get { return "Giwin"; } }
        public override Version Version { get { return new Version(1, 2); } }
        public override bool WantButton { get { return false; } }

        public string NameOfPlugin = "AIMLWhisper";
        public string SendChatMessageChatChannel = "Whisper";
        public string DoubleDash = "\\";
        public string MainPath = "Plugins" + "\\" + "AIMLWhisper" + "\\" + "logs" + "\\";
        public string AIMLPath = "Plugins" + "\\" + "AIMLWhisper" + "\\" + "aiml";
        public string DayShort = String.Format("{0:dd}", DateTime.Now);
        public string Day = String.Format("{0:dddd}", DateTime.Now);
        public string Month = String.Format("{0:MMMM}", DateTime.Now);
        public string Year = String.Format("{0:yyyy}", DateTime.Now);
        public string TimeSentReceived = string.Format("Date: {0}/{1}/{2} - Time: {3}", DateTime.Now.Day.ToString(CultureInfo.InvariantCulture), DateTime.Now.Month.ToString(CultureInfo.InvariantCulture), DateTime.Now.Year.ToString(CultureInfo.InvariantCulture), DateTime.Now.ToLongTimeString());

        public char[] CharsToTrim = { '.' };

        public override void Initialize()
        {
            Logging.Write("[" + NameOfPlugin + "]: " + Version + " " + "Loaded");
            Chat.Whisper += WoWChatWhisper; // Hook event
            _aimlBot = new Bot();
            _aimlBot.loadSettings();
            _aimlBot.loadAIMLFromFiles();
            _userList = new List<User>();
            _responseList = new List<Response>();
        }

        public void WoWChatWhisper(Chat.ChatSimpleMessageEventArgs e)
        {
            User user = _userList.Find(o => o.UserID == e.Args[1].ToString());

            if (user == null)
            {
                user = new User(e.Args[1].ToString(), _aimlBot);
                _userList.Add(user);
            }

            Result result = _aimlBot.Chat(new Request(e.Message, user, _aimlBot));

            if (!_responseList.Contains(new Response(user.UserID, result.Output)))
            {
                if (e.Args[1].ToString() != StyxWoW.Me.Name && e.Args[0].ToString() != "")
                {
                    _responseList.Add(new Response(user.UserID, result.Output));

                    if (File.Exists(MainPath + DoubleDash + Year + DoubleDash + Month + DoubleDash + DayShort + DoubleDash + Day + ".txt"))
                    {
                        using (StreamWriter writer = File.AppendText(MainPath + Year + DoubleDash + Month + DoubleDash + DayShort + DoubleDash + Day + ".txt"))
                        {
                            string received = "[" + NameOfPlugin + "]: " + string.Format("Time: {0}", DateTime.Now.ToLongTimeString() + " | Received - " + e.Args[1] + ": " + e.Args[0]);
                            string sent = "[" + NameOfPlugin + "]: " + string.Format("Time: {0}", DateTime.Now.ToLongTimeString() + " | Sent - " + e.Args[1] + ": " + result.Output.TrimEnd(CharsToTrim));

                            Logging.Write(received);
                            writer.WriteLine(received);
                            writer.WriteLine(received.Remove(received.Length));

                            if (result.Output.TrimEnd(CharsToTrim) != "" && result.Output.TrimEnd(CharsToTrim) != " " && result.Output.TrimEnd(CharsToTrim).Length != 0)
                            {
                                Logging.Write(sent);
                                writer.WriteLine(sent);
                                writer.WriteLine(sent.Remove(received.Length));
                            }
                        }
                    }
                    else if (!Directory.Exists(MainPath + DoubleDash + Year + DoubleDash + Month + DoubleDash + DayShort))
                    {
                        Logging.Write("[" + NameOfPlugin + "]: " + "Directory Created - " + Year + "/" + Month + "/" + DayShort);
                        Directory.CreateDirectory(MainPath + DoubleDash + Year + DoubleDash + Month + DoubleDash + DayShort);
                    }
                    else if (!File.Exists(MainPath + DoubleDash + Year + DoubleDash + Month + DoubleDash + DayShort + DoubleDash + Day + ".txt") &&
                              Directory.Exists(MainPath + DoubleDash + Year + DoubleDash + Month + DoubleDash + DayShort))
                    {
                        Logging.Write("[" + NameOfPlugin + "]: " + "File Created - " + Year + "/" + Month + "/" + DayShort + "/" + Day + ".txt");
                        File.Create(MainPath + DoubleDash + Year + DoubleDash + Month + DoubleDash + DayShort + DoubleDash + Day + ".txt");
                    }
                }
            }
        }


        private void TrySend(Response response)
        {
            if (_responseList.Count > 0 && !string.IsNullOrEmpty(response.Message))
                Thread.Sleep(new Random().Next(4794, 7639));
                        Styx.WoWInternals.Lua.DoString(String.Format("SendChatMessage(\"{0}\", \"" + SendChatMessageChatChannel + "\", nil, \"{1}\");", response.Message.TrimEnd(CharsToTrim), response.User));
            _responseList.Clear();
        }

        public override void Pulse()
        {
            if (StyxWoW.Me == null || !StyxWoW.Me.IsAlive || !StyxWoW.IsInGame || !StyxWoW.IsInWorld) return;

            if (_responseList.Count != 0)
            {
                TrySend(_responseList.First());
            }
        }
    }
}